%define anolis_release 2
%global __requires_exclude_from %{?__requires_exclude_from:%__requires_exclude_from|}%{_datadir}/doc/
%global base_version 3.13

Name:           perl-Thread-Queue
Version:        3.14
Release:        %{anolis_release}%{?dist}
Summary:        Thread-safe queues
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/Thread-Queue
Source0:        https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/Thread-Queue-%{base_version}.tar.gz
Patch0:         Thread-Queue-3.13-Upgrade-to-3.14.patch

BuildArch:      noarch
BuildRequires:  make perl-generators perl-interpreter perl(strict) perl(warnings)
BuildRequires:  perl(Config) perl(ExtUtils::MakeMaker) >= 6.76 perl(Carp) perl(Scalar::Util) >= 1.10
BuildRequires:  perl(threads::shared) >= 1.21 perl(Exporter) perl(Thread::Semaphore) perl(threads)
BuildRequires:  perl(Test::More) >= 0.50

Requires:       perl(Carp)

%description
This module provides thread-safe FIFO queues that can be accessed safely by
any number of threads.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n Thread-Queue-%{base_version}
sed -i -e '1 s|^#!/usr/bin/env perl|%(perl -MConfig -e 'print $Config{startperl}')|' examples/queue.pl

%build
perl Makefile.PL NO_PACKLIST=1 INSTALLDIRS=vendor
%make_build

%install
%make_build pure_install DESTDIR=$RPM_BUILD_ROOT
%{_fixperms} $RPM_BUILD_ROOT/*

%check
%make_build test

%files
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files doc
%doc Changes README examples

%changelog
* Tue Apr 11 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 3.14-2
- Optimize the spec file

* Fri Feb 10 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.14-1
- update to version 3.14

* Fri Feb 03 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.13-3
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 3.13-2
- rebuild with perl 5.36.0

* Thu Apr 21 2022 yuanhui <yuanhui@linux.alibaba.com> - 3.13-1
- Init perl-Thread-Queue for anolis os 23
